Public Class addEditEmployees
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeading As System.Web.UI.WebControls.Label
    Protected WithEvents btnSubmit As System.Web.UI.WebControls.Button
    Protected WithEvents txtFirstName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtLastName As System.Web.UI.WebControls.TextBox
    Protected WithEvents cboDepartment As System.Web.UI.WebControls.DropDownList
    Protected WithEvents cboPosition As System.Web.UI.WebControls.DropDownList
    Protected WithEvents txtAddress As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtCity As System.Web.UI.WebControls.TextBox
    Protected WithEvents cboState As System.Web.UI.WebControls.DropDownList
    Protected WithEvents txtZipcode As System.Web.UI.WebControls.TextBox
    Protected WithEvents chkMgr As System.Web.UI.WebControls.CheckBox
    Protected WithEvents txtSalary As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Public dml As New DataManipulationLayer
    Public strEmployeeID As String
    Public blnIsUpdate As Boolean
    Public dtEmployee As DataTable
    Public dtDepartment As DataTable
    Public dtPosition As DataTable
    Public dtState As DataTable
    Public dr As DataRow

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        strEmployeeID = Request.QueryString("EmployeeID")

        'If an employeeID was passed then we are updating
        'otherwise we are adding
        If Not strEmployeeID Is Nothing Then
            blnIsUpdate = True
        Else
            blnIsUpdate = False
        End If

        If Not Page.IsPostBack Then
            'open the connection
            dml.Open()

            'Get Department information for department dropdown
            dtDepartment = dml.Query("stp_GetDepartments")
            cboDepartment.DataSource = dtDepartment
            cboDepartment.DataTextField = "DepartmentName"
            cboDepartment.DataValueField = "DepartmentID"
            cboDepartment.DataBind()

            'Get Position information for position dropdown
            dtPosition = dml.Query("stp_GetPositions")
            cboPosition.DataSource = dtPosition
            cboPosition.DataTextField = "PositionName"
            cboPosition.DataValueField = "PositionID"
            cboPosition.DataBind()

            'Get States for state dropdown
            dtState = dml.Query("stp_GetStates")
            cboState.DataSource = dtState
            cboState.DataTextField = "StateDesc"
            cboState.DataValueField = "StateCode"
            cboState.DataBind()

            'Get employee information
            If blnIsUpdate = True Then
                lblHeading.Text = "Editing Employee"

                dtEmployee = dml.Query("stp_GetEmployeeByEmployeeID", New String() {"@EmployeeID", strEmployeeID})

                For Each dr In dtEmployee.Rows
                    txtFirstName.Text = dr("FirstName").ToString
                    txtLastName.Text = dr("LastName").ToString
                    cboDepartment.SelectedValue = dr("DepartmentID").ToString
                    cboPosition.SelectedValue = dr("PositionID").ToString
                    txtAddress.Text = dr("Address").ToString
                    txtCity.Text = dr("City").ToString
                    cboState.SelectedValue = dr("State").ToString
                    txtZipcode.Text = dr("Zipcode").ToString
                    chkMgr.Checked = Convert.ToBoolean(dr("IsMgr"))
                    txtSalary.Text = FormatNumber(dr("Salary").ToString, 0, TriState.False, TriState.False, TriState.False)
                Next

            Else
                lblHeading.Text = "Adding Employee"
            End If

            'close the connection
            dml.Close()
        End If
    End Sub

    Private Sub btnSubmit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSubmit.Click
        Dim strFirstName As String
        Dim strLastName As String
        Dim strDepartmentID As String
        Dim strPositionID As String
        Dim strAddress As String
        Dim strCity As String
        Dim strState As String
        Dim strZipcode As String
        Dim strIsMgr As String
        Dim strSalary As String

        If Page.IsPostBack Then
            strFirstName = txtFirstName.Text.ToString
            strLastName = txtLastName.Text.ToString
            strDepartmentID = cboDepartment.SelectedValue.ToString
            strPositionID = cboPosition.SelectedValue.ToString
            strAddress = txtAddress.Text.ToString
            strCity = txtCity.Text.ToString
            strState = cboState.SelectedValue.ToString
            strZipcode = txtZipcode.Text.ToString

            If chkMgr.Checked = True Then
                strIsMgr = "-1"
            Else
                strIsMgr = "0"
            End If

            strSalary = txtSalary.Text.ToString
        End If

        Try
            dml.Open()

            If blnIsUpdate = True Then
                dml.Query("stp_UpdateEmployee", New String() {"@EmployeeID", strEmployeeID, "@DepartmentID", strDepartmentID, "@PositionID", strPositionID, "@FirstName", strFirstName, "@LastName", strLastName, "@Address", strAddress, "@City", strCity, "@State", strState, "@Zipcode", strZipcode, "@IsMgr", strIsMgr, "@Salary", strSalary})
            Else
                dml.Query("stp_InsertNewEmployee", New String() {"@DepartmentID", strDepartmentID, "@PositionID", strPositionID, "@FirstName", strFirstName, "@LastName", strLastName, "@Address", strAddress, "@City", strCity, "@State", strState, "@Zipcode", strZipcode, "@IsMgr", strIsMgr, "@Salary", strSalary})
            End If
        Catch ex As Exception
            Response.Write("Error: " & ex.Message & "<br>" & ex.StackTrace)
        Finally
            dml.Close()
        End Try

        Response.Redirect("ListEmployees.aspx")
    End Sub
End Class
